`timescale 1ns / 1ps

module mul_64_wrapper(input clk,
                      output reg data_o
    );
    
    /*
    reg [63:0] a,b;
    wire [127:0] c;
    
    always @(posedge clk) begin
        a <= a + 1;
        b <= b + 1;
        data_o <= ^c;
    end
    */
    
    reg in_a,in_b,sel;
    
    always@(posedge clk) begin
        in_a <= in_a + 1;
        in_b <= in_b + 1;
        sel <= ~sel;
    end
    
    reg [63:0] a,b;
    wire [127:0] c;
    reg [127:0] c_r;
    
    always @(posedge clk) begin
        a <= {a[62:0],in_a};
        b <= {b[62:0],in_b};
        c_r <= (sel == 0) ? c : {c_r[126:0],c_r[127]};
    end
    
    always @(*) begin
        data_o = c_r[0];
    end
    
    mul_64 unit0(clk,a,b,c);
    
endmodule
